classdef SimParameters
    %LUT_SCALE Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        Params;
        Species;
        InitialValues;
        Reactions;
        IonWallReactions;
        NeutralWallReactions;
        ElasticCollisions;
        
    end
    
    methods
        function obj = SimParameters(inputfile)
            %LUT_SCALE Construct an instance of this class
            %   Detailed explanation goes here
            obj.Params = parameters.params(inputfile);
            obj.Species = initialization.get_species(obj.Params);
            obj.InitialValues = initialization.get_initialValues(obj.Params);
            obj.Reactions = initialization.get_reactions(obj.Params);
            obj.IonWallReactions = initialization.get_ionWallReactions(obj.Params);
            obj.NeutralWallReactions = initialization.get_neutralWallReactions(obj.Params);
            obj.ElasticCollisions = initialization.get_elasticCollisionReactions(obj.Params);
        end
        
        function [parameters,species,initialvalues,reactions,ionwallreactoins,...
                neutralwallreactions,elasticcollisions] = provide_all(obj)
            %METHOD1 Summary of this method goes here
            %   Detailed explanation goes here
            parameters = obj.Params;
            species = obj.Species;
            initialvalues = obj.InitialValues;
            reactions = obj.Reactions;
            ionwallreactoins = obj.IonWallReactions;
            neutralwallreactions = obj.NeutralWallReactions;
            elasticcollisions = obj.ElasticCollisions;
        end
        
        function species = provide_species(obj)
            species = obj.Species;
        end
        
        function reactions = provide_reactions(obj)
            reactions = obj.Reactions; 
        end
        function prms = provide_parameters(obj)
            prms = obj.Params;
        end
        
        
        function species_energies = provide_species_energies(obj)
            species_energies = str2double(erase(obj.Species{2},'eV'))';
        end
        
        function species_names = provide_species_names(obj)
            species_names = string(obj.Species{1}');
        end
        
        function index_str = SpeciesIndex(obj,str)
            species_energies = obj.provide_species_energies;
            species_names = obj.provide_species_names;
            if isempty(find(strcmp(species_names,str)))==1
                disp('The species is absent in the species csv file.')
            else
                index_str = find(strcmp(species_names,str));
            end
        end
        function energy = Energy(obj,str)
            species_energies = obj.provide_species_energies;
            species_names = obj.provide_species_names;
            index_str = find(strcmp(species_names,str));
            energy = species_energies(1,index_str);
        end
               
    end
end

