classdef parameters
    %UNTITLED9 Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
    end
    
    methods (Static)
        
        function [Return] = params(inputfile)
            %UNTITLED7 Summary of this function goes here
            %   Detailed explanation goes here
            
            ConstantFile = inputfile; 
            addpath('InputFolder');
            Input = parameters.ImportConstants([ConstantFile]);
            sz = size(Input);
            
            while sz(2) ~= 3
                ConstFileFail = input('Please insert a correct input file: ');
                Input = parameters.ImportConstants(ConstFileFail);
                sz = size(Input);
            end
            
            % Constants
            fin                 = Input{parameters.FindCellIndicies(Input,'OutputFolder',ConstantFile,1),3};
            mkdir(['Output/' fin]);
            addpath('Output',['Output/' fin]);
            constants.Frequency = str2double(Input{parameters.FindCellIndicies(Input,'Frequency',ConstantFile,1),3});
            constants.Voltage   = str2double(Input{parameters.FindCellIndicies(Input,'Voltage',ConstantFile,1),3});
            constants.kB        = str2double(Input{parameters.FindCellIndicies(Input,'kB',ConstantFile,1),3});
            constants.e_eVtoJ   = str2double(Input{parameters.FindCellIndicies(Input,'e_eVtoJ',ConstantFile,1),3});
            constants.e_eVtoK   = str2double(Input{parameters.FindCellIndicies(Input,'e_eVtoK',ConstantFile,1),3});
            constants.mass_amu  = str2double(Input{parameters.FindCellIndicies(Input,'mass_amu',ConstantFile,1),3}); 
            constants.mass_e    = str2double(Input{parameters.FindCellIndicies(Input,'mass_e',ConstantFile,1),3}); 
            constants.P         = str2double(Input{parameters.FindCellIndicies(Input,'P',ConstantFile,1),3});
            constants.if_M         = str2double(Input{parameters.FindCellIndicies(Input,'if_M',ConstantFile,1),3});
            
            % Plasma parameter
            plasParam.ReacShape = Input{parameters.FindCellIndicies(Input,'ReactorShape',ConstantFile,1),3};
            plasParam.X        = str2double(Input{parameters.FindCellIndicies(Input,'X',ConstantFile,1),3});
            plasParam.Y        = str2double(Input{parameters.FindCellIndicies(Input,'Y',ConstantFile,1),3});
            plasParam.Radius   = str2double(Input{parameters.FindCellIndicies(Input,'Radius',ConstantFile,1),3});
            plasParam.L        = str2double(Input{parameters.FindCellIndicies(Input,'L',ConstantFile,1),3});
            plasParam.Watt     = str2double(Input{parameters.FindCellIndicies(Input,'Watt',ConstantFile,1),3});
            plasParam.mySigma  = str2double(Input{parameters.FindCellIndicies(Input,'mySigma',ConstantFile,1),3});
            
            % Gas Flow
            flow.index_flowIn  = str2double(Input{parameters.FindCellIndicies(Input,'index_flowIn',ConstantFile,1),3});
            flow.index_flowIn2 = str2double(Input{parameters.FindCellIndicies(Input,'index_flowIn2',ConstantFile,1),3});
            flow.index_flowIn3 = str2double(Input{parameters.FindCellIndicies(Input,'index_flowIn3',ConstantFile,1),3});
            flow.gas_ratio2    = str2double(Input{parameters.FindCellIndicies(Input,'gas_ratio2',ConstantFile,1),3});
            flow.gas_ratio3    = str2double(Input{parameters.FindCellIndicies(Input,'gas_ratio3',ConstantFile,1),3});
            flow.Q_in          = str2double(Input{parameters.FindCellIndicies(Input,'Q_in',ConstantFile,1),3});
            flow.Q_out         = str2double(Input{parameters.FindCellIndicies(Input,'Q_out',ConstantFile,1),3});
            flow.C             = str2double(Input{parameters.FindCellIndicies(Input,'C',ConstantFile,1),3});
            flow.P_atom        = str2double(Input{parameters.FindCellIndicies(Input,'P_atom',ConstantFile,1),3});
            flow.T_in         = str2double(Input{parameters.FindCellIndicies(Input,'T_in',ConstantFile,1),3});
            
            %Input Files
            inputFiles.species                   = Input{parameters.FindCellIndicies(Input,'species',ConstantFile,1),3};
            inputFiles.reactions_previous        = Input{parameters.FindCellIndicies(Input,'reactions_previous',ConstantFile,1),3};
            inputFiles.reactions                 = Input{parameters.FindCellIndicies(Input,'reactions',ConstantFile,1),3};
            inputFiles.initialValues             = Input{parameters.FindCellIndicies(Input,'initialValues',ConstantFile,1),3};
            inputFiles.speciesProperties         = Input{parameters.FindCellIndicies(Input,'speciesProperties',ConstantFile,1),3};
            inputFiles.ionWallReactions          = Input{parameters.FindCellIndicies(Input,'ionWallReactions',ConstantFile,1),3};
            inputFiles.neutralWallReactions      = Input{parameters.FindCellIndicies(Input,'neutralWallReactions',ConstantFile,1),3};
            inputFiles.elasticCollision_previous = Input{parameters.FindCellIndicies(Input,'elasticCollisions_previous',ConstantFile,1),3};
            inputFiles.elasticCollision          = Input{parameters.FindCellIndicies(Input,'elasticCollisions',ConstantFile,1),3};
            inputFiles.lokinames                 = Input{parameters.FindCellIndicies(Input,'lokinames',ConstantFile,1),3};
            inputFiles.lokiVibPop{1}             = Input{parameters.FindCellIndicies(Input,'lokiVib_Pop1',ConstantFile,1),3};
            inputFiles.lokiVibPop{2}             = Input{parameters.FindCellIndicies(Input,'lokiVib_Pop2',ConstantFile,1),3};
            
            
            % Collation of parameters
            Return.constants = constants;
            Return.plasParam = plasParam;
            Return.flow = flow;
            Return.inputFiles = inputFiles;
            Return.OutputFolder = fin;
        end
        
        
        function Input = ImportConstants(filename, startRow, endRow) 
            % Auto-generated by MATLAB on 2017/01/24 13:31:08
            
            %% Initialize variables.
            delimiter = ' ';
            if nargin<=2
                startRow = 1;
                endRow = inf;
            end
            
            %% Format string for each line of text:
            %   column1: text (%s)
            %	column2: text (%s)
            %   column3: text (%s)
            % For more information, see the TEXTSCAN documentation.
            formatSpec = '%s%s%s%[^\n\r]';
            
            %% Open the text file.
            fileID = fopen(filename,'r');
            
            %% Read columns of data according to format string.
            % This call is based on the structure of the file used to generate this
            % code. If an error occurs for a different file, try regenerating the code
            % from the Import Tool.
            
            textscan(fileID, '%[^\n\r]', startRow(1)-1, 'ReturnOnError', false);
            dataArray = textscan(fileID, formatSpec, endRow(1)-startRow(1)+1, 'Delimiter', delimiter, 'MultipleDelimsAsOne', true, 'ReturnOnError', false);
            for block=2:length(startRow)
                frewind(fileID);
                textscan(fileID, '%[^\n\r]', startRow(block)-1, 'ReturnOnError', false);
                dataArrayBlock = textscan(fileID, formatSpec, endRow(block)-startRow(block)+1, 'Delimiter', delimiter, 'MultipleDelimsAsOne', true, 'ReturnOnError', false);
                for col=1:length(dataArray)
                    dataArray{col} = [dataArray{col};dataArrayBlock{col}];
                end
            end
            
            %% Close the text file.
            fclose(fileID);
            %% Create output variable
            Input = [dataArray{1:end-1}];
        end
        
        
        function fi = FindCellIndicies(Input,inputname,InputFile,varargin)
            if  isempty(varargin)
                warn = 0;
            else
                warn = varargin{1};
            end
            
            f = strcmp(Input,inputname);
            fi = find(f(:,1));
            
            if warn
                if length(fi) > 1
                    warning(['More than one entry for ', inputname, ' found, using the first and ignoring the latters']);
                    fi = fi(1);
                elseif isempty(fi)
                    error(['No entry for ', inputname, ' found in ',InputFile]);
                end
            end
        end
        
    end
    
end

